<script lang="ts">
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getPageMetadata } from '~/common/meta';
import { CONTENT_TYPES } from '~/common/content-types';
import { getClient } from '~/plugins/contentful.js';
import { NextStepAlt } from '~/components/common/index.vue';
import {
  PressButton,
  PressHero,
  PressKitNav,
  PressSection,
} from '~/components/press/index.vue';
import { PressData, pressKitHelper } from '~/services/press/press.service';

export default {
  name: 'PresKit',
  components: {
    NextStepAlt,
    PressSection,
    PressHero,
    PressKitNav,
    PressButton,
  },
  nuxtI18n: false,
  async asyncData() {
    const content: PressData = await getClient()
      .getEntries({
        content_type: CONTENT_TYPES.PAGE,
        include: 3,
        'fields.slug': 'press',
      })
      .then((query: any) => {
        const entryFields = query.items[0]?.fields;
        return pressKitHelper(entryFields);
      })
      .catch((e) => {
        throw new Error(e);
      });
    return { content };
  },
  head(): MetaInfo {
    return {
      ...getPageMetadata((this as any).content, this.$route.path),
    };
  },
};
</script>
<template>
  <div>
    <PressHero :data="content?.hero" />
    <div class="press-container">
      <PressKitNav :data="content?.navigation" />
      <component
        :is="component.name"
        v-for="(component, index) in content?.components"
        :key="component.header || `press-grid-${index}`"
        :data="component"
      />
    </div>
    <NextStepAlt />
  </div>
</template>

<style lang="scss" scoped>
.press-container {
  background: #f9f9f9;
  padding-bottom: $spacing-160;
}
</style>
